Package org.springframework.aop.framework

# Class AbstractSingletonProxyFactoryBean

java.lang.Object
org.springframework.aop.framework.ProxyConfig
org.springframework.aop.framework.AbstractSingletonProxyFactoryBean

All Implemented Interfaces:
  `Serializable`, `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanClassLoaderAware`, `org.springframework.beans.factory.FactoryBean<Object>`, `org.springframework.beans.factory.InitializingBean`

public abstract class AbstractSingletonProxyFactoryBean extends ProxyConfig implements org.springframework.beans.factory.FactoryBean<Object>, org.springframework.beans.factory.BeanClassLoaderAware, org.springframework.beans.factory.InitializingBean
Convenient superclass for `FactoryBean` types that produce singleton-scoped proxy objects.

Manages pre- and post-interceptors (references, rather than interceptor names, as in `ProxyFactoryBean`) and provides consistent interface management.

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  - Serialized Form

## Field Summary

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractSingletonProxyFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
`protected abstract Object`
`createMainInterceptor()`
Create the "main" interceptor for this proxy factory bean.
`protected TargetSource`
`createTargetSource(Object target)`
Determine a TargetSource for the given target (or TargetSource).
`Object`
`getObject()`
`Class<?>`
`getObjectType()`
`final boolean`
`isSingleton()`
`protected void`
`postProcessProxyFactory(ProxyFactory proxyFactory)`
A hook for subclasses to post-process the `ProxyFactory` before creating the proxy instance with it.
`void`
`setAdvisorAdapterRegistry(AdvisorAdapterRegistry advisorAdapterRegistry)`
Specify the AdvisorAdapterRegistry to use.
`void`
`setBeanClassLoader(ClassLoader classLoader)`
`void`
`setPostInterceptors(Object[] postInterceptors)`
Set additional interceptors (or advisors) to be applied after the implicit transaction interceptor.
`void`
`setPreInterceptors(Object[] preInterceptors)`
Set additional interceptors (or advisors) to be applied before the implicit transaction interceptor, for example, a PerformanceMonitorInterceptor.
`void`
`setProxyClassLoader(ClassLoader classLoader)`
Set the ClassLoader to generate the proxy class in.
`void`
`setProxyInterfaces(Class<?>[] proxyInterfaces)`
Specify the set of interfaces being proxied.
`void`
`setTarget(Object target)`
Set the target object, that is, the bean to be wrapped with a transactional proxy.

### Methods inherited from class org.springframework.aop.framework.ProxyConfig

`copyFrom, isExposeProxy, isFrozen, isOpaque, isOptimize, isProxyTargetClass, setExposeProxy, setFrozen, setOpaque, setOptimize, setProxyTargetClass, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### AbstractSingletonProxyFactoryBean

public AbstractSingletonProxyFactoryBean()

## Method Details

### setTarget

public void setTarget(Object target)
Set the target object, that is, the bean to be wrapped with a transactional proxy.

The target may be any object, in which case a SingletonTargetSource will be created. If it is a TargetSource, no wrapper TargetSource is created: This enables the use of a pooling or prototype TargetSource etc.

See Also:
  - `TargetSource`
  - `SingletonTargetSource`
  - `LazyInitTargetSource`
  - `PrototypeTargetSource`
  - `CommonsPool2TargetSource`

### setProxyInterfaces

public void setProxyInterfaces(Class<?>[] proxyInterfaces)
Specify the set of interfaces being proxied.

If not specified (the default), the AOP infrastructure works out which interfaces need proxying by analyzing the target, proxying all the interfaces that the target object implements.

### setPreInterceptors

public void setPreInterceptors(Object[] preInterceptors)
Set additional interceptors (or advisors) to be applied before the implicit transaction interceptor, for example, a PerformanceMonitorInterceptor.

You may specify any AOP Alliance MethodInterceptors or other Spring AOP Advices, as well as Spring AOP Advisors.

See Also:
  - `PerformanceMonitorInterceptor`

### setPostInterceptors

public void setPostInterceptors(Object[] postInterceptors)
Set additional interceptors (or advisors) to be applied after the implicit transaction interceptor.

You may specify any AOP Alliance MethodInterceptors or other Spring AOP Advices, as well as Spring AOP Advisors.

### setAdvisorAdapterRegistry

public void setAdvisorAdapterRegistry(AdvisorAdapterRegistry advisorAdapterRegistry)
Specify the AdvisorAdapterRegistry to use. Default is the global AdvisorAdapterRegistry.

See Also:
  - `GlobalAdvisorAdapterRegistry`

### setProxyClassLoader

public void setProxyClassLoader(ClassLoader classLoader)
Set the ClassLoader to generate the proxy class in.

Default is the bean ClassLoader, i.e. the ClassLoader used by the containing BeanFactory for loading all bean classes. This can be overridden here for specific proxies.

### setBeanClassLoader

public void setBeanClassLoader(ClassLoader classLoader)

Specified by:
  `setBeanClassLoader` in interface `org.springframework.beans.factory.BeanClassLoaderAware`

### afterPropertiesSet

public void afterPropertiesSet()

Specified by:
  `afterPropertiesSet` in interface `org.springframework.beans.factory.InitializingBean`

### createTargetSource

protected TargetSource createTargetSource(Object target)
Determine a TargetSource for the given target (or TargetSource).

Parameters:
  `target` - the target. If this is an implementation of TargetSource it is used as our TargetSource; otherwise it is wrapped in a SingletonTargetSource.
Returns:
  a TargetSource for this object

### postProcessProxyFactory

protected void postProcessProxyFactory(ProxyFactory proxyFactory)
A hook for subclasses to post-process the `ProxyFactory` before creating the proxy instance with it.

Parameters:
  `proxyFactory` - the AOP ProxyFactory about to be used
Since:
  4.2

### getObject

public Object getObject()

Specified by:
  `getObject` in interface `org.springframework.beans.factory.FactoryBean<Object>`

### getObjectType

@Nullable public Class<?> getObjectType()

Specified by:
  `getObjectType` in interface `org.springframework.beans.factory.FactoryBean<Object>`

### isSingleton

public final boolean isSingleton()

Specified by:
  `isSingleton` in interface `org.springframework.beans.factory.FactoryBean<Object>`

### createMainInterceptor

protected abstract Object createMainInterceptor()
Create the "main" interceptor for this proxy factory bean. Typically an Advisor, but can also be any type of Advice.

Pre-interceptors will be applied before, post-interceptors will be applied after this interceptor.